/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.EncodingProviderGenerator;

import com.google.inject.Injector;
import com.google.inject.Singleton;

/**
 * Generator for {@link Phenotype} providers. It is served as a singleton from the guice
 * {@link Injector}.
 * 
 * @author diewald
 */
@Singleton
public class PhenotypeProviderGenerator extends EncodingProviderGenerator<Phenotype> {

	/** Constructor. */
	public PhenotypeProviderGenerator(
			Collection<Class<? extends Phenotype>> encodingTypesToProvide) {
		super(encodingTypesToProvide);
	}
}
