/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.platform;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.platform.PlatformCommunicationGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.NopMutateOperator;
import org.opt4j.operators.mutate.MutateModule;

/**
 * Defines a no-op mutation for {@link PlatformCommunicationGraphEncoding}s. "Real" mutation will be
 * added later.
 * 
 * @author diewald
 */
public class NopPlatformCommGraphMutateModule extends MutateModule {
	/** {@inheritDoc} */
	@Override
	protected void config() {
		addOperator(PlatformCommunicationGraphEncoding.class, NopMutateOperator.class);
	}
}
