/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.TaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.sysmodel.random.RandomExploration;
import org.opt4j.operators.mutate.BasicMutateModule;
import org.opt4j.operators.mutate.Mutate;
import org.opt4j.operators.selection.RandomOperatorSelector;

import com.google.inject.Module;

/**
 * This {@link Module} registers {@link Mutate} operators in Opt4J which manipulate the
 * {@link TaskMappingEncoding}s.
 * 
 * @author huang
 * @author diewald
 */
// TODO: Generic handling.
public class MutateTaskMappingModule extends BasicMutateModule {

	/** {@inheritDoc} */
	@SuppressWarnings("unchecked")
	@Override
	public void config() {
		super.config();

		addOperatorSelectorInstance(AbstractTaskMappingEncoding.class, Mutate.class,
				new RandomOperatorSelector(RandomExploration.getInstance()));
		addOperator(AbstractTaskMappingEncoding.class,
				(Class<? extends Mutate<AbstractTaskMappingEncoding>>)MutateAllocation.class);
		addOperator(AbstractTaskMappingEncoding.class,
				(Class<? extends Mutate<AbstractTaskMappingEncoding>>)MutateRedundancyDecrement.class);
		addOperator(AbstractTaskMappingEncoding.class,
				(Class<? extends Mutate<AbstractTaskMappingEncoding>>)MutateRedundancyIncrement.class);
	}
}
