/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.evaluator;

import org.opt4j.core.Value;

/**
 * Base class for {@link Value} wrappers. It allows to derive {@link Value} on the fly if needed.
 * 
 * @author diewald
 */
public abstract class GenericValue<V> implements Value<V> {

	/** The wrapped instance. */
	private V value;

	/** Constructor. */
	public GenericValue(V value) {
		this.value = value;
	}

	/** {@inheritDoc} */
	@Override
	public int compareTo(Value<V> o) {
		return this.getDouble().compareTo(o.getDouble());
	}

	/** {@inheritDoc} */
	@Override
	public V getValue() {
		return value;
	}

	/** {@inheritDoc} */
	@Override
	public void setValue(V value) {
		this.value = value;
	}
}
